/* $VER: FinalWrapper 1.4 (18.05.94) by NDY's */

/* Main [1.4] */
OPTIONS RESULTS
SIGNAL ON ERROR
SIGNAL ON SYNTAX
initerr=init()
ADDRESS VALUE port
CALL locale
CALL chosenobjs
CALL options
CALL pointnoval
IF txt>0 THEN
  CALL textblock
ELSE
  CALL bodytext
CALL initwrap
CALL wrap
CALL group
CALL bye

PROC init: /* Initialization [1.4] */
  /* Vars needed by "bye" / "ERROR" */
  errtext='"%t" "(#%n) in line %l" "" "Ok" "" ""'
  objs=0
  deci=""
  et=""
  lib=0
  /* Started by Final Writer? */
  port=ADDRESS()
  portok=Left(port,7)="FINALW."
  IF ~portok THEN
    DO i=1 TO 10 UNTIL portok
      port="FINALW."||i
      portok=Show("p",port)
    END
  IF ~portok THEN RETURN 13
  /* Open library */
  library="rexxmathlib.library"
  lib=Show("l",library)
  IF ~lib THEN lib=AddLib(library,0,-30,0)
  IF ~lib THEN RETURN 14
  clip="FWrapper.def"
  default=GetClip(clip)
RETURN 0
PROC locale: /* Language specific strings [1.4] */
  test=0  /* test 1/2/3/4/6/10/20/100/200 WITH new languages, 0 = no test */
  lang=getlanguage()
  info='FinalWrapper 1.4 by NDY''s'
  /* IF default='' THEN default='(put your defaults here and uncomment this line)' */
  IF lang="deutsch" THEN /* German */
    DO
      errtext='"FinalWrapper-Fehler:" "%t" "in Zeile %l (Fehlernummer %n)" "Ok" "" ""'
      noselect='"FinalWrapper-Fehler:" "Zuerst einen Textblock oder einen" "Textausschnitt und ein Oval whlen!" "Ok" "" ""'
      input='"%i" "Sektorgrsse eingeben (? fr Hilfe)" "%d"'
      help.0='"Syntax (alle Argumente optional, | trennt Alternativen):" "n|n||An|An|A D|D= R|R=|Rn|Rn G Sn|Sn|S @n Hn J|J= O ?" "A: Sektorgrsse (0 bis 360), - Text umdrehen. Voreinst.: 360. A = A360"'
      help.1='"Rotieren: Voreinstellung: +0. R+ entspricht R+90, R- R-90" "R+n / R-n dreht jedes Zeichen um weitere n Grad (0 bis 180)" "Rn setzt die Drehung aller Zeichen auf n, R= gleich der des Textblocks"'
      help.2='"D (Lschen): Voreinst.: Nur Oval wird gelscht. D+ auch" "der Textblock wird gelscht. D- weder Oval noch" "Textblock gelscht. D= Oval wird kopiert und gelscht"'
      help.3='"Gruppierung: Voreinst.: Oval nicht mitgruppieren" "G+ Oval zum Objekt hinzugruppieren" "G- Oval unsichtbar hinzugruppieren"'
      help.4='"Startpunkt: Voreinstellung: 0" "S+n/S-n: Anfang um n Grad gegen/mit Uhrzeigersinn" "verschieben. Sn: Start beim Winkel n. S = S90"'
      help.5='"@ (Spirale): Voreinst.: 0.  @n erzeugt eine Spirale mit ei-" "nem inneren Radius von n% des usseren. @-n funktio-" "niert analog, jedoch beginnt die Spirale im Innern"'
      help.6='"Hhe: Voreinst.: Wert von @, wenn angegeben," "sonst 0. Hn funktioniert wie @n, betrifft aber" "die Grsse der Zeichen statt des Radius"'
      help.7='"J (Anpassen): Voreinst.: Nichts anpassen." "J- Zeichenbreite anpassen, J+ auch Hhe anpassen" "J= Sektor an Zeichenbreite anpassen"'
      help.8='"Optionen speichern: Voreinst.: Nicht speichern" "O+ alle Optionen speichern" "O- alle ausser O- speichern und Abbruch"'
      helpbutton='"Letzte Seite" "Zurck" "Nchste Seite"'
      helppages=9
      fwerrtext.10='Befehl gescheitert'
      fwerrtext.20='Ungltige Argumente'
      fwerrtext.100='Befehl unbekannt'
      fwerrtext.200='Kann fwarexx.library nicht ffnen'
      nolib='"FinalWrapper-Fehler:" "Konnte ''%y'' nicht ffnen!" "" "Ok" "" ""'
      nofw='FinalWrapper-Fehler: Final Writer nicht gefunden!'
    END
  ELSE /* Default: English */
    DO
      errtext='"FinalWrapper failed:" "%t" "in line %l (errornumber %n)" "Ok" "" ""'
      noselect='"FinalWrapper failed:" "Select an oval and a textblock or" "some text before calling FinalWrapper!" "Ok" "" ""'
      input='"%i" "Enter sector size (? for help)" "%d"'
      help.0='"Syntax (all arguments are optional, | separates alternatives):" "n|n||An|An|A D|D= R|R=|Rn|Rn G Sn|Sn|S @n Hn J|J= O ?" "Angle: Sectorsize (0 to 360), - flips the text. Default: 360. A = A360"'
      help.1='"Rotate: Default: +0. R+ is equal to R+90, R- to R-90" "R+n / R-n rotates each letter for another n degrees (0 to 180)" "Rn sets rotation of all letters to n, R= equal to the textblock''s"'
      help.2='"Delete: Default: Only oval deleted. D+ deletes" "the textblock as well. D- prevents the oval from" "being deleted. D= copies oval before deleting it"'
      help.3='"Group: Default: Don''t group." "G+ group oval to object" "G- make oval invisible and group it"'
      help.4='"Starting point: Default: 0" "S+n moves the start n degree anticlockwise," "S-n clockwise. Sn: start at angle n. S = S90."'
      help.5='"@ (spiral): Default: 0. @n creates a spiral with an inner" "radius of n% of the outer one. @-n works equal" "exept that the spiral now starts at the inside"'
      help.6='"Height: Default: Value from @ if given, else 0" "Hn works as @n, but it affects the height of" "the characters, not the radius"'
      help.7='"J (Adjust): Default: Don''t adjust." "J- adjusts width, J+ also height of characters" "J= adjusts the sector size to the character width"'
      help.8='"Save options: Default: Don''t save" "O+ save all options" "O- save all options exept O- and cancel"'
      helpbutton='"Previous" "Back" "Next"'
      helppages=9
      fwerrtext.10='Instruction failed'
      fwerrtext.20='Invalid arguments'
      fwerrtext.100='Unknown instruction'
      fwerrtext.200='Couldn''t open fwarexx.library'
      nolib='"FinalWrapper failed:" "Couldn''t open ''%y''" "" "Ok" "" ""'
      nofw='FinalWrapper failed: Final Writer not found!'
    END
  input=replacepat(input,"%i",info)
  IF test=4 | initerr=13 THEN
    DO
      SAY nofw
      CALL bye(13)
    END
  IF test=1 | initerr=14 THEN
    DO
      ShowMessage 1 1 replacepat(nolib,"%y",library)
      CALL bye(14)
    END
  IF test>5 THEN
    DO
      RC=test
      IF test=6 THEN SIGNAL SYNTAX
      SIGNAL ERROR
    END
RETURN
PROC chosenobjs: /* Selected objects [1.4] */
  /* Selected objects */
  txt=0
  oval=0
  len=0
  FirstObject "SELECTED"
  o=RESULT
  IF o~=0 THEN
    DO
      cnt=0
      DO UNTIL o=0
        obj.cnt=o
        NextObject o "SELECTED"
        o=RESULT
        cnt=cnt+1
      END
      /* Search oval and textblock */
      DO i=0 TO cnt-1 WHILE oval=0 | txt=0
        GetObjectType obj.i
        IF RESULT=7 THEN txt=obj.i
        IF RESULT=6 THEN oval=obj.i
      END
      /* Selected text */
      IF txt=0 THEN
        DO
          Status "PARAPOS"
          pos=RESULT
          IF Words(pos)=4 THEN
            DO
              Extract
              text=RESULT
              MoveToPara Word(pos,1) Word(pos,2)
              len=Length(text)
            END
          ELSE
            DO
              IF Word(pos,2)~=0 THEN MoveToPara Word(pos,1) 0
              Status "PARACHARS"
              len=RESULT
              text=""
            END
        END
    END
  IF (txt=0 & len=0 | oval=0 | test=2) & test~=3 THEN
    DO
      ShowMessage 1 1 noselect
      CALL bye(5)
    END
RETURN
PROC options: /* Input [1.4] */
  about=0
  DO UNTIL about=-1 & test~=3
    RequestText replacepat(input,"%d",default)
    /* Help */
    IF Pos("?",RESULT)>0 | test=3 THEN
      DO
        default=replacepat(RESULT,"?","")
        about=0
        DO UNTIL RESULT=2
          ShowMessage 2 0 help.about helpbutton
          about=(about+RESULT-2+helppages)//helppages
        END
      END
    ELSE
      about=-1
  END
  RESULT=replacepat(RESULT,",",".")
  PARSE UPPER VAR RESULT "A" ssize " ","D" del " ","R" rrot " ","G" grp " ","S" start " ","@" rdim " ","H" hdim " ","O" opt " ","J" adjust " "
  IF opt="-" THEN 
    DO
      CALL SetClip(clip,Trim(replacepat(Upper(RESULT),"O-","")))
      CALL bye(0)
    END
  IF opt="+" THEN CALL SetClip(clip,Upper(RESULT))
  IF ssize="" THEN PARSE UPPER VAR RESULT ssize " "
  /* Verify and set defaults (x||"0":  -> 0) */
  IF ssize="+" | ssize="-" THEN ssize=ssize||"360"
  IF ~Datatype(ssize,"N") | ssize="" THEN ssize=360
  IF ssize=0 THEN ssize=0.01 /* no division by zero */
  IF ~Datatype(rrot||"0","N") & rrot~="=" THEN rrot=""
  IF grp~="+" & grp~="-" THEN grp=""
  IF start="+" | start="-" THEN start=start||"90"
  IF ~Datatype(start,"N") | start="" THEN start="+0"
  absstart=0
  IF Verify(Left(start,1),"+-","m")=0 THEN
    DO
      absstart=1
      start=Max(Min(start,360),0)
    END
  ELSE
    start=Max(Min(start,180),-180)
  IF del~="+" & del~="-" & del~="=" THEN del=""
  IF ~Datatype(hdim,"N") THEN hdim=""
  IF ~Datatype(rdim,"N") THEN rdim=""
  IF rdim="" THEN
    ssize=Max(Min(ssize,360),-360)
  ELSE
    rdim=Max(Min(rdim,100),-100)
  IF rdim=0 THEN rdim=0.01
  IF ~Datatype(hdim,"N") THEN hdim=""
  IF hdim="" THEN
    hdim=rdim
  ELSE
    hdim=Max(Min(hdim,100),-100)
  IF hdim=0 THEN hdim=0.01
  IF adjust~="+" & adjust~="-" & adjust~="=" THEN adjust=""
  /* Relative rotation */
  drot=0
  IF Verify(Left(rrot,1),"+-","m")>0 THEN
    DO
      IF Length(rrot)=1 THEN
        drot=rrot||"90"
      ELSE
        drot=Max(Min(rrot,180),-180)
      rrot=""
    END
  ELSE
    IF rrot~="" & rrot~="=" THEN rrot=Max(Min(rrot,360),-360)
RETURN
PROC pointnoval: /* Decimal point & process oval [1.3] */
  /* Use decimal point */
  GetDocItemPrefs "DECIMAL"
  deci=RESULT
  DocItemPrefs "DECIMAL PERIOD"
  /* Examine oval */
  GetObjectRotation oval
  orot=RESULT
  IF orot~=0 THEN SetObjectRotation oval 0
  GetObjectCoords oval
  PARSE VAR RESULT page x y rx ry
  rx=rx/2
  ry=ry/2
  xm=x+rx
  ym=y+ry
  /* Use oval's text flow settings */
  GetObjectParams oval "TEXTFLOW FLOWDIST"
  flow=Word(RESULT,1)
  IF Left(flow,5)="Right" THEN
    flow="Right"
  ELSE
    IF Left(flow,4)="Left" THEN flow="Left"
  fld=Word(RESULT,2)
  TextBlockPrefs "TEXTFLOW" flow "FLOWDIST" fld
  IF del="=" THEN
    DO
      SelectObject oval
      Copy
    END
  IF del~="-" & grp="" THEN DeleteObject oval
RETURN
PROC textblock: /*  Process textblock [1.4] */
  /* Examine textblock */
  GetTextBlockText txt
  text=RESULT
  text=rembad(text)
  len=Length(text)
  GetObjectTypeSpecs txt "SIZE LEADING WIDTH OBLIQUE POSITION CASE STYLE COLOR FONT"
  PARSE VAR RESULT size lead wid obl pos case st col font
  TextBlockTypePrefs "SIZE" size "LEADING" lead "WIDTH" wid "OBLIQUE" obl "POSITION" pos "CASE" case "STYLE" st "COLOR" col "FONT" font
  GetObjectCoords txt
  txtw=Word(RESULT,4)
  h=Word(RESULT,5)
  /* Get rotation */
  IF rrot="=" THEN
    DO
      GetObjectRotation txt
      rrot=RESULT
    END
  IF del="+" THEN DeleteObject txt
RETURN
PROC bodytext: /* Process selected text [1.4] */
  IF rrot="=" THEN rrot=0
  txtw=0
  /* Remove CR at the end */
  IF C2X(Right(text,1))="0A" THEN
    DO
      len=len-1
      text=Left(text,len)
    END
  text=rembad(text)
  /* Create textobjects */
  DO i=1 TO len
    IF text>"" THEN
      x=SubStr(text,i,1)
    ELSE
      DO
        Extract
        x=RESULT
      END
    Cursor "RIGHT"
    specs=gettexttypespecs()
    TextBlockTypePrefs specs
    IF Verify(x,'";= ',"M")  THEN x='"'||x||'"'
    DrawTextBlock page xm ym x
    /* Save size & number */
    objs=objs+1
    GetObjectCoords 0
    PARSE VAR RESULT x x x objw.objs objh.objs
    txtw=txtw+objw.objs
    CurrentObject
    obj.objs=RESULT
  END
RETURN
PROC initwrap: /* Init wrapping [1.4] */
  PI=3.141593
  smin=0.1 /* Minimal size */
  sizerad=ssize/180*PI
  angstep=sizerad/txtw
  IF absstart THEN
    angstart=start/180*PI
  ELSE
    angstart=(ssize-360+start*2)/360*PI
  adone=angstart
  flip=Sign(ssize)
  ssize=ssize<0
  fr=0
  IF rdim="" THEN
    qr=1
  ELSE
    DO
      fr=(1-Abs(rdim)/100)/sizerad*Sign(rdim)
      IF rdim<0 THEN
        fr0=Abs(rdim)/100
      ELSE
        fr0=1
    END
  IF hdim="" THEN
    qh=1
  ELSE
    DO
      fh=(1-Abs(hdim)/100)/sizerad*Sign(hdim)
      IF hdim<0 THEN
        fh0=Abs(hdim)/100
      ELSE
        fh0=1
    END
  wdone=0
  o=0
  nr=0
RETURN
PROC wrap: /* Wrap it! [1.4] */
  DO n=1 TO len
    char=SubStr(text,n,1)
    IF txt>0 THEN
      DO
        /* Draw and get size */
        IF Verify(char,'";= ',"M")  THEN char='"'||char||'"'
        DrawTextBlock page xm ym char
        GetObjectCoords 0
        cw=Word(RESULT,4)
        ch=h
        CurrentObject
        objs=objs+1
        obj.objs=RESULT
      END
    ELSE
      DO
        /* Number and size saved before */
        nr=nr+1
        cw=objw.nr
        ch=objh.nr
        o=obj.nr
      END
    f=angstart-angstep*(wdone+cw/2)
    wdone=wdone+cw
    /* Adjusting */
    IF adjust="=" THEN
      DO
        asize=cw/radius(adone,rx,ry,fr)
        f=adone-asize/2*flip
        adone=adone-asize*flip
      END
    ELSE
      IF adjust~="" THEN
        DO
          carc=radius(f,rx,ry,fr)*angstep*cw
          IF adjust="+" THEN ch=ch/cw*carc
          cw=carc
        END
    /* Spirals */
    IF rdim~="" THEN qr=fr0+fr*(f-angstart)
    IF hdim~="" THEN
      DO
        qh=fh0+fh*(f-angstart)
        ch=Max(ch*qh,smin)
        cw=Max(cw*qh,smin)
      END
    x=rx*Sin(f)*qr-cw/2
    y=ry*Cos(f)*qr-ch/2
    /* Rotation */
    IF rrot="" THEN
      rot=720-Trunc(Atan(ry/rx*Tan(f))/PI*180)+180*((Cos(f)>0)+ssize)+drot
      /* Circles only: rot=Trunc(ssize*180+180-f/PI*180)+drot */
    ELSE
      rot=rrot
    /* Centre char on the oval */
    SetObjectCoords o page x+xm y+ym cw ch
    SetObjectRotation o rot//360
  END
RETURN
PROC group: /* Group objects [1.4] */
  /* Hide oval */
  IF grp="-" THEN
    DO
      SelectObject oval
      SetObjectParams oval "LINEWT NONE FILL TRANSPARENT"
    END
  /* Rotate oval back */
  IF orot~=0 & del="-" & grp="" THEN SetObjectRotation oval orot
  /* Group chars */
  SelectObject
  DO n=1 TO objs
    SelectObject obj.n "MULTIPLE"
  END
  IF grp~="" THEN SelectObject oval "MULTIPLE"
  Group
  objs=0
  IF orot~=0 THEN SetObjectRotation 0 orot
  Redraw
RETURN
PROC bye: /* CALL bye(returnvalue)  You MUST use this instead of EXIT! [1.4] */
  PARSE ARG errnr
  /* Restore decimal delimitter */
  IF deci~="" THEN DocItemPrefs "DECIMAL" deci
  IF lib=1 THEN CALL RemLib(library)
  IF objs~=0 THEN
    DO
      SelectObject
      DO n=1 TO objs
        SelectObject obj.n "MULTIPLE"
      END
      Group
      DeleteObject
    END
  EXIT errnr
RETURN
PROC SYNTAX: /* SYNTAX & ERROR handling [1.3] */
  et=ErrorText(RC)
ERROR:
  line=SIGL
  nr=RC
  IF et="" THEN et=fwerrtext.nr
  IF nr>5 THEN ShowMessage 1 1 replacepat(replacepat(replacepat(errtext,"%n",nr),"%l",line),"%t",et)
  CALL bye(nr)
RETURN
PROC rembad: PROCEDURE /* newstr=rembad(str) [1.1] */
  /* Replace unprintable characters by spaces */
  PARSE ARG t
  bad=XRange("00"x,"1F"x)||XRange("7F"x,"9F"x)
  i=Verify(t,bad,"m")
  l=Length(t)
  DO WHILE i>0
    t=Left(t,i-1) Right(t,l-i)
    i=Verify(t,bad,"m")
  END
RETURN t
PROC replacepat: PROCEDURE /* newstr=replacepat(str,pat,replc) [1.2] */
  /* Replace all occurences of a pattern in a string by another one */
  PARSE ARG str,pat,replc
  p=Pos(pat,str)
  DO WHILE p>0
    str=Left(str,p-1)||replc||SubStr(str,p+Length(pat))
    p=Pos(pat,str)
  END
RETURN str
PROC getlanguage: PROCEDURE /* language=getlanguage() [1.3] */
  /* Get preferred language */
  ok=Open(prefs,"ENV:Locale","R")
  IF ok THEN
    DO
      language=ReadLn(prefs)
      CALL Close(prefs)
    END
RETURN language
PROC gettexttypespecs: PROCEDURE /*  specs=gettexttypespecs() [1.3] */
  Status "FONTSIZE"
  p="SIZE" RESULT
  Status "FONTLEADING"
  p=p "LEADING" RESULT
  Status "FONTWIDTH"
  p=p "WIDTH" RESULT
  Status "FONTOBLIQUE"
  p=p "OBLIQUE" RESULT
  Status "FONTPOSITION"
  p=p "POSITION" RESULT
  Status "FONTCASE"
  p=p "CASE" RESULT
  Status "FONTSTYLE"
  p=p "STYLE" RESULT
  Status "FONTCOLOR"
  p=p "COLOR" RESULT
  Status "FONTNAME"
  p=p "FONT" RESULT
RETURN p
PROC radius: PROCEDURE /* rad=radius(angle,rx,ry,v) [1.4] */
  ARG a,rx,ry,v
  rx=rx*Cos(a)
  ry=ry*Sin(a)
  r=(1-a*v)*Sqrt(rx*rx+ry*ry)
RETURN r
PROC dump: PROCEDURE /* CALL dump(var[,infostr]) [1.3] */
  /* Dump a variable, %v in infostring determines it's place (debug-only) */
  PARSE ARG v,info
  IF info="" THEN info="%v"
  ShowMessage 1 1 '"'||replacepat(info,"%v",v)||'" "" "" "Ok" "" ""'
RETURN
